Program Upgrade_Latrine_below_v2_6;

uses dos,crt,mstuff;

type
  older_out_player = record
                account : byte;
                machine : boolean;
                alive : boolean;
                been : boolean;
                find : boolean;
                c1 : boolean;
                c2 : boolean;
                fight : byte;
               end;

  out_player = record
                real_name : string[50]; {BBS name}
                handle : string[20]; {Handle in LORD}
                account : byte; {Account # in LORD}
                chal : boolean; {Are they challenged for drinking contest?}
                challenges : integer; {How many challenges left?}
                contest : integer; {How many contests have they won?}
                drunk : boolean; {Are they drunk?}
                expert_m : boolean; {Expert Mode on?}
                whore : boolean; {Been with whore?}
                machine : boolean; {Look at Mechanism on wall (main menu)}
                alive : boolean; {Alive?}
                times : integer; {How many times have they been to the bathroom?}
                been : boolean; {Been to the bathroom?}
                find : boolean; {Searched in "Deeper" menu?}
                c1 : boolean; {Done a cheat code?}
                c2 : boolean; {Done a cheat code?}
                fight : byte; {# of dungeon fights}
               end;

 player_info = record
  names: string[20]; {player handle in the game}
  real_names: string[50] {real name/or handle from BBS} ;
  hit_points  {player hit points}
  ,bad  {don't know - might not be used at all}
  ,rate: integer; {again, couldn't find this one in the source}
  hit_max: integer; {hit_point max}
  weapon_num: integer; {weapon number}
  weapon: string[20]; {name of weapon}
  seen_master: integer; {equals 5 if seen master, else 0}
  fights_left: integer; {forest fights left}
  human_left: integer; {human fights left}
  gold: longint; {gold in hand}
  bank: longint; {gold in bank}
  def: integer;  {total defense points }
  strength: integer; {total strength}
  charm: integer; {good looking meter}
  seen_dragon: integer; {seen dragon?  5 if yes else 0}
  seen_violet: integer; {seen violet?  5 if yes else 0}
  level: integer; {level of player}
  time: word; {day # that player last played on}
  arm: string[20]; {armour name}
  arm_num: integer; {armour number}
  dead: shortint; {player dead?  5 if yes else 0}
  inn: shortint; {player sleeping at inn?  5 if yes else 0}
  gem: integer; {# of gems on hand}
  exp: longint; {experience}
  sex: shortint; {gender, 5 if female else 0}
  seen_bard: shortint; {seen bard?  5 if yes else 0}
  last_alive_time: integer; {day # player was last reincarnated on}
  Lays: integer; {players lays stat}
  Why: integer; {not used yet}
  on_now: boolean; {is player on?}
  m_time: integer; {day on_now stat was last used}
  time_on: string[5]; {time player logged on in Hour:Minutes format}
  class: shortint; {class, should be 1, 2 or 3}
  extra: integer;      {*NEW*  If 1, player has a horse}
  love: string[25]; {not used - may be used for inter-player marrages later}
  married: integer; {who player is married to, should be -1 if not married}
  kids: integer; {# of kids}
  king: integer; {# of times player has won game}
  skillw: shortint; {number of Death Knight skill points}
  skillm: shortint; {number of Mystical Skills points}
  skillt: shortint; {number of Thieving Skills points}

  levelw: shortint; {number of Death Knight skill uses left today}
  levelm: shortint; {number of Mystical skill uses left today}
  levelt: shortint; {number of Thieving skill uses left today}

  inn_random: boolean; {not used yet}
  married_to: integer; {same as Married, I think - don't know why it's here}
  v1: longint;
  v2: integer; {# of player kills}
  v3: integer; {if 5, 'wierd' event in forest will happen}
  v4: boolean; {has player done 'special' for that day?}
  v5: shortint; {has player flirted with another player that day?  if so, 5}
  new_stat1: shortint;
  new_stat2: shortint;  {these 3 are unused right now}
  new_stat3: shortint;  {Warning: Joseph's NPCLORD screws with all three}
 end;

var
  o1: file of older_out_player;
  o2: file of out_player;
  lf: file of player_info;
  old: older_out_player;
  out: out_player;
  lord_dir,lat_dir : string;
  f : text;
  lord : player_info;
  i : integer;

Begin
  assign(f,'LATRINE.CFG');
  if exist('LATRINE.CFG') then reset(f) else
  Begin
    writeln;
    writeln('ERROR: LATRINE.CFG file not found.  Please copy VXX_V30 to the directory where');
    writeln('LATRINE.CFG is located, and execute it from there.');halt(0);
  end;
  readln(f,lord_dir);
  readln(f,lat_dir);
  close(f);
  assign(o1,lat_dir+'LPLYRS.DAT');
  assign(o2,lat_dir+'LPLYRS2.DAT');
  assign(lf,lord_dir+'PLAYER.DAT');
  if exist(lat_dir+'LPLYRS.DAT') then reset(o1) else
  Begin
    writeln;
    writeln('ERROR: LPLYRS.DAT file not found.  You have no need to run this program.  Please don''t.');
    halt(0);
  end;
  rewrite(o2);
  if exist(lord_dir+'PLAYER.DAT') then reset(lf) else
  Begin
    writeln;
    writeln('ERROR: '+lord_dir+'PLAYER.DAT file not found.  Please make sure you have set the');
    writeln('correct paths in the Latrine''s configuration program.');
    halt(0);
  end;
  repeat
    read(o1,old);
    seek(lf,old.account);
    read(lf,lord);
    out.real_name:=lord.real_names;
    out.handle:=lord.names;
    out.account:=old.account;
    out.chal:=false;
    out.challenges:=3;
    out.contest:=0;
    out.machine:=old.machine;
    out.expert_m:=false;
    out.drunk:=false;
    out.whore:=false;
    out.alive:=old.alive;
    out.times:=0;
    out.been:=old.been;
    out.find:=old.find;
    out.c1:=old.c1;
    out.c2:=old.c2;
    out.fight:=old.fight;
    write(o2,out);
  until eof(o1);
  close(o1);
  close(o2);
  close(lf);
  erase(o1);
  rename(o2,lat_dir+'LPLYRS.DAT');
  writeln;
  write('Reading');
  for i := 1 to 5 do
  Begin
    delay(150);
    write('.');
  end;
  delay(150);
  writeln('.');
  write('Writing');
  for i := 1 to 5 do
  Begin
    delay(150);
    write('.');
  end;
  delay(150);
  writeln('.');
  delay(250);
  writeln('Done!');writeln;
  writeln('Your data files for the Latrine are now compatible with version 3.0.');
end.